
; ================================================================================
;                                      test
;                               www.carirographics.org
;                                   version 1.8 
;
;               you are free to use this code for any purpose
;
;Cairo is free software and is available to be redistributed and/or modified under the 
;terms of either the GNU Lesser General Public License (LGPL) version 2.1 
;Or the Mozilla Public License (MPL) version 1.1 at your option.
;
; please refer to the examples in the cairo site,
; note that this code isn't optimised at all sorry for that.
; 
;{ 

 XIncludeFile "cairo180.pbi"

 Enumeration
 #cairo_example_pdf
 #cairo_example_svg
 #cairo_example_png
 #cairo_example_ps
 EndEnumeration

 Global ps.PAINTSTRUCT, rr.RECT, refresh.i
 
 Procedure clear_cr(cr)

    cairo_set_source_rgb (cr, 1, 1, 1)
    cairo_paint (cr)
    
 EndProcedure 

 Procedure arc(cr)
    Protected xc.d, yc.d, radius.d, angle1.d, angle2.d
    
    clear_cr(cr)
    
    xc = WindowWidth(1)/2;128.0
    yc = WindowHeight(1)/2;128.0
    radius = 100.0
    angle1 = 45.0  * (#M_PI/180.0);  /* angles are specified */
    angle2 = 180.0 * (#M_PI/180.0);  /* in radians           */
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0)
    cairo_set_line_width (cr, 10.0);
    cairo_arc (cr, xc, yc, radius, angle1, angle2);
    cairo_stroke (cr);
    
    cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.3);
    cairo_set_line_width (cr, 6.0);
    
    cairo_arc (cr, xc, yc, 10.0, 0, 2*#M_PI);
    cairo_fill (cr);
    
    cairo_arc (cr, xc, yc, radius, angle1, angle1);
    cairo_line_to (cr, xc, yc);
    cairo_arc (cr, xc, yc, radius, angle2, angle2);
    cairo_line_to (cr, xc, yc);
    cairo_stroke (cr)
    cairo_restore(cr)
    refresh = 2 ; i'm to busy to do other think for refreshing the window :)
 EndProcedure 

 Procedure arc_negative(cr)
   Protected xc.d, yc.d, radius.d, angle1.d, angle2.d
   
   clear_cr(cr)
   
    xc = WindowWidth(1)/2;128.0
    yc = WindowHeight(1)/2;128.0
     radius = 100.0;
     angle1 = 45.0  * (#M_PI/180.0);  /* angles are specified */
     angle2 = 180.0 * (#M_PI/180.0);  /* in radians           */
      cairo_save(cr)
      cairo_set_source_rgb (cr, 0, 0, 0)
      cairo_set_line_width (cr, 10.0);
      cairo_arc_negative (cr, xc, yc, radius, angle1, angle2);
      cairo_stroke (cr);
      
      cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.3);
      cairo_set_line_width (cr, 6.0);
      
      cairo_arc (cr, xc, yc, 10.0, 0, 2*#M_PI);
      cairo_fill (cr);
      
      cairo_arc (cr, xc, yc, radius, angle1, angle1);
      cairo_line_to (cr, xc, yc);
      cairo_arc (cr, xc, yc, radius, angle2, angle2);
      cairo_line_to (cr, xc, yc);
      cairo_stroke (cr)
      cairo_restore(cr)
      refresh = 3
 EndProcedure 

 Procedure clip(cr)
    Protected xc.d, yc.d

    clear_cr(cr)
    
    cairo_save (cr)
    xc = WindowWidth(1)/2;128.0
    yc = WindowHeight(1)/2;128.0
    
    cairo_set_source_rgb (cr, 0, 0, 0)      
    cairo_arc (cr, xc, yc, 76.8, 0, 2 * #M_PI);
    cairo_clip (cr);
      
    cairo_new_path (cr);  /* current path is not consumed by cairo_clip() */
    cairo_rectangle (cr, 0, 0, xc*2, yc*2);
    cairo_fill (cr);
    cairo_set_source_rgb (cr, 0, 1, 0);
    cairo_move_to (cr, 0, 0);
    cairo_line_to (cr, xc*2, yc*2);
    cairo_move_to (cr, xc*2, 0);
    cairo_line_to (cr, 0, yc*2);
    cairo_set_line_width (cr, 10.0);
    cairo_stroke (cr);  
    cairo_restore(cr)
    refresh = 4
 EndProcedure 

 Procedure clip_image(cr,image_path.s) ; image in png format
    Protected xc.d, yc.d

    clear_cr(cr)

    xc = WindowWidth(1)/2;128.0
    yc = WindowHeight(1)/2;128.0
    
    cairo_save(cr)    
    cairo_arc (cr, xc, yc, 176.8, 0, 2*#M_PI);
    cairo_clip (cr);
    cairo_new_path (cr); /* path not consumed by clip()*/
      
    image = cairo_image_surface_create_from_png (image_path);
    w = cairo_image_surface_get_width (image);
    h = cairo_image_surface_get_height (image);
      
    cairo_scale (cr, (xc*2)/w, (yc*2)/h);
    cairo_set_source_surface (cr, image, 0, 0);
    cairo_paint (cr);
    cairo_surface_destroy (image) 
    cairo_restore(cr) 
    refresh = 5
 EndProcedure 

 Procedure curve_rectangle(cr)
   Protected x0.d, y0.d, x1.d, y1.d, rect_width.d, rect_height.d, xc.d, yc.d
     
     clear_cr(cr)
     xc = WindowWidth(1)/2;128.0
     yc = WindowHeight(1)/2;128.0
     rect_width  = 204.8
     rect_height = 204.8
     x0      = xc - (rect_width /2);   /* parameters like cairo_rectangle */
     y0      = yc - (rect_height/2)
     radius = 102.4;   /* and an approximate curvature radius */

        x1=x0+rect_width;
        y1=y0+rect_height;
        cairo_save(cr) 
        If (rect_width/2<radius) 
            If (rect_height/2<radius) 
                cairo_move_to  (cr, x0, (y0 + y1)/2);
                cairo_curve_to (cr, x0 ,y0, x0, y0, (x0 + x1)/2, y0);
                cairo_curve_to (cr, x1, y0, x1, y0, x1, (y0 + y1)/2);
                cairo_curve_to (cr, x1, y1, x1, y1, (x1 + x0)/2, y1);
                cairo_curve_to (cr, x0, y1, x0, y1, x0, (y0 + y1)/2);
             Else 
                cairo_move_to  (cr, x0, y0 + radius);
                cairo_curve_to (cr, x0 ,y0, x0, y0, (x0 + x1)/2, y0);
                cairo_curve_to (cr, x1, y0, x1, y0, x1, y0 + radius);
                cairo_line_to (cr, x1 , y1 - radius);
                cairo_curve_to (cr, x1, y1, x1, y1, (x1 + x0)/2, y1);
                cairo_curve_to (cr, x0, y1, x0, y1, x0, y1- radius);
            EndIf
         Else 
            If (rect_height/2<radius) 
                cairo_move_to  (cr, x0, (y0 + y1)/2);
                cairo_curve_to (cr, x0 , y0, x0 , y0, x0 + radius, y0);
                cairo_line_to (cr, x1 - radius, y0);
                cairo_curve_to (cr, x1, y0, x1, y0, x1, (y0 + y1)/2);
                cairo_curve_to (cr, x1, y1, x1, y1, x1 - radius, y1);
                cairo_line_to (cr, x0 + radius, y1);
                cairo_curve_to (cr, x0, y1, x0, y1, x0, (y0 + y1)/2);
            Else 
                cairo_move_to  (cr, x0, y0 + radius);
                cairo_curve_to (cr, x0 , y0, x0 , y0, x0 + radius, y0);
                cairo_line_to (cr, x1 - radius, y0);
                cairo_curve_to (cr, x1, y0, x1, y0, x1, y0 + radius);
                cairo_line_to (cr, x1 , y1 - radius);
                cairo_curve_to (cr, x1, y1, x1, y1, x1 - radius, y1);
                cairo_line_to (cr, x0 + radius, y1);
                cairo_curve_to (cr, x0, y1, x0, y1, x0, y1- radius);
            EndIf
          EndIf   
        cairo_close_path (cr);
        
        cairo_set_source_rgb (cr, 0.5, 0.5, 1);
        cairo_fill_preserve (cr);
        cairo_set_source_rgba (cr, 0.5, 0, 0, 0.5);
        cairo_set_line_width (cr, 10.0);
        cairo_stroke (cr);
        cairo_restore(cr)
        refresh = 6
 EndProcedure 

 Procedure curve_to(cr)
  Protected x.d, y.d, x1.d, y1.d, x2.d, y2.d, x3.d, y3.d, xc.d, yc.d

     clear_cr(cr)
     xc = WindowWidth(1)/3;128.0
     yc = WindowHeight(1)/3;128.0  
      x=xc +25.6
      y=yc +128.0;
      x1=xc + 102.4
      y1=yc +230.4
      x2=xc +153.6
      y2=yc +25.6
      x3=xc +230.4
      y3=yc +128.0
      cairo_save(cr)
      cairo_set_source_rgb (cr, 0, 0, 0) 
      cairo_move_to (cr, x, y);
      cairo_curve_to (cr, x1, y1, x2, y2, x3, y3);
      
      cairo_set_line_width (cr, 2.0);
      cairo_stroke (cr);
      
      cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.3);
      cairo_set_line_width (cr, 6.0);
      cairo_move_to (cr,x,y);   
      cairo_line_to (cr,x1,y1);
      cairo_move_to (cr,x2,y2); 
      cairo_line_to (cr,x3,y3);
      cairo_stroke (cr); 
      cairo_restore(cr)
      refresh = 7
 EndProcedure 

 Procedure dashes(cr)
    Protected xc.d, yc.d, ndash, offset.d
    Dim tdashes.d(4) 
  
    clear_cr(cr)
    
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 
    xc = WindowWidth(1)/2;128.0
     yc = WindowHeight(1)/2;128.0

       tdashes(0) = 50
       tdashes(1) = 10.0
       tdashes(2) = 10.0
       tdashes(3) = 10.0
       ndash  = 4
       offset = -50.0;

      cairo_set_dash (cr, @tdashes(0), ndash, offset);
      cairo_set_line_width (cr, 10.0);
      
      cairo_move_to (cr, 128.0, 25.6);
      cairo_line_to (cr, 230.4, 230.4);
      cairo_rel_line_to (cr, -102.4, 0.0);
      cairo_curve_to (cr, 51.2, 230.4, 51.2, 128.0, 128.0, 128.0);
      
      cairo_stroke (cr)
     cairo_restore(cr) 
     refresh = 8
 EndProcedure 

 Procedure fill_and_stroke(cr)
   Protected xc.d, yc.d
    clear_cr(cr)
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 

       cairo_move_to (cr, 128.0, 25.6);
      cairo_line_to (cr, 230.4, 230.4);
      cairo_rel_line_to (cr, -102.4, 0.0);
      cairo_curve_to (cr, 51.2, 230.4, 51.2, 128.0, 128.0, 128.0);
      cairo_close_path (cr);
      
      cairo_move_to (cr, 64.0, 25.6);
      cairo_rel_line_to (cr, 51.2, 51.2);
      cairo_rel_line_to (cr, -51.2, 51.2);
      cairo_rel_line_to (cr, -51.2, -51.2);
      cairo_close_path (cr);
      
      cairo_set_line_width (cr, 10.0);
      cairo_set_source_rgb (cr, 0, 0, 1);
      cairo_fill_preserve (cr);
      cairo_set_source_rgb (cr, 0, 0, 0);
      cairo_stroke (cr);
      cairo_restore(cr)     
     refresh = 9
 EndProcedure 

 Procedure fill_style(cr)
   clear_cr(cr)
    
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 
     
      cairo_set_line_width (cr, 6);

      cairo_rectangle (cr, 12, 12, 232, 70);
      cairo_new_sub_path (cr); 
      cairo_arc (cr, 64, 64, 40, 0, 2*#M_PI);
      cairo_new_sub_path (cr); 
      cairo_arc_negative (cr, 192, 64, 40, 0, -2*#M_PI);
      
      cairo_set_fill_rule (cr, #CAIRO_FILL_RULE_EVEN_ODD);
      cairo_set_source_rgb (cr, 0, 0.7, 0);
      cairo_fill_preserve (cr);
      cairo_set_source_rgb (cr, 0, 0, 0); 
      cairo_stroke (cr);
      
      cairo_translate (cr, 0, 128);
      cairo_rectangle (cr, 12, 12, 232, 70);
      cairo_new_sub_path (cr); 
      cairo_arc (cr, 64, 64, 40, 0, 2*#M_PI);
      cairo_new_sub_path (cr); 
      cairo_arc_negative (cr, 192, 64, 40, 0, -2*#M_PI);
      
      cairo_set_fill_rule (cr, #CAIRO_FILL_RULE_WINDING);
      cairo_set_source_rgb (cr, 0, 0, 0.9); 
      cairo_fill_preserve (cr);
      cairo_set_source_rgb (cr, 0, 0, 0); 
      cairo_stroke (cr);
      cairo_restore(cr)
      refresh = 10
 EndProcedure 

 Procedure gradient(cr)
   clear_cr(cr)
    
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 
    xc = WindowWidth(1)/2;128.0
     yc = WindowHeight(1)/2;128.0
     
      pat = cairo_pattern_create_linear (0.0, 0.0,  0.0, 256.0);
      cairo_pattern_add_color_stop_rgba (pat, 1, 0, 0, 0, 1);
      cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
      cairo_rectangle (cr, 0, 0, 256, 256);
      cairo_set_source (cr, pat);
      cairo_fill (cr);
      cairo_pattern_destroy (pat);
      
      pat = cairo_pattern_create_radial (115.2, 102.4, 25.6, 102.4,  102.4, 128.0);
      cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
      cairo_pattern_add_color_stop_rgba (pat, 1, 0, 0, 0, 1);
      cairo_set_source (cr, pat);
      cairo_arc (cr, 128.0, 128.0, 76.8, 0, 2 * #M_PI);
      cairo_fill (cr);
      cairo_pattern_destroy (pat)
     cairo_restore(cr)
      refresh = 11
 EndProcedure 

 Procedure image(cr,image_path.s)
   Protected xc.d, yc.d
   clear_cr(cr)
    
      cairo_save(cr)
      cairo_set_source_rgb (cr, 0, 0, 0) 
      xc = WindowWidth(1)/2;128.0
      yc = WindowHeight(1)/2;128.0
      image = cairo_image_surface_create_from_png (image_path);
      w = cairo_image_surface_get_width (image);
      h = cairo_image_surface_get_height (image);
      
      cairo_translate (cr, 128.0, 128.0);
      cairo_rotate (cr, 45* #M_PI/180);
      cairo_scale  (cr, 256.0/w, 256.0/h);
      cairo_translate (cr, -0.5*w, -0.5*h);
      
      cairo_set_source_surface (cr, image, 0, 0);
      cairo_paint (cr);
      cairo_surface_destroy (image);
      cairo_restore(cr)    
      refresh = 12
 EndProcedure 

 Procedure image_pattern(cr,image_path.s)
   Protected xc.d, yc.d, matrix.cairo_matrix_t
   clear_cr(cr)
    
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 
    xc = WindowWidth(1)/2;128.0
     yc = WindowHeight(1)/2;128.0
      image = cairo_image_surface_create_from_png (image_path);
      w = cairo_image_surface_get_width (image);
      h = cairo_image_surface_get_height (image);
      
      pattern = cairo_pattern_create_for_surface (image);
      cairo_pattern_set_extend (pattern, #CAIRO_EXTEND_REPEAT);
      
      cairo_translate (cr, 128.0, 128.0);
      cairo_rotate (cr, #M_PI / 4);
      cairo_scale (cr, 1.5, 1.5);
      cairo_scale (cr, 1 / Sqr (2), 1 / Sqr (2));
      cairo_translate (cr, -128.0, -128.0);
      
      cairo_matrix_init_scale (matrix, w/256.0 * 5.0, h/256.0 * 5.0);
      cairo_pattern_set_matrix (pattern, matrix);
      
      cairo_set_source (cr, pattern);
      
      cairo_rectangle (cr, 0, 0, 256.0, 256.0);
      cairo_fill (cr);
      
      cairo_pattern_destroy (pattern);
      cairo_surface_destroy (image) 
      cairo_restore(cr)    
      refresh = 13
 EndProcedure 

 Procedure multi_segment_cap(cr)
   
   clear_cr(cr)
    
   cairo_save(cr)
   cairo_set_source_rgb (cr, 0, 0, 0) 

      cairo_move_to (cr, 50.0, 75.0);
      cairo_line_to (cr, 200.0, 75.0);
      
      cairo_move_to (cr, 50.0, 125.0);
      cairo_line_to (cr, 200.0, 125.0);
      
      cairo_move_to (cr, 50.0, 175.0);
      cairo_line_to (cr, 200.0, 175.0);
      
      cairo_set_line_width (cr, 30.0);
      cairo_set_line_cap (cr, #CAIRO_LINE_CAP_ROUND);
      cairo_stroke (cr);
;       cairo_show_page(cr)
      cairo_restore(cr)
      refresh = 14
 EndProcedure 

 Procedure set_line_cap(cr)
   clear_cr(cr)
    
        cairo_save(cr)
        cairo_set_source_rgb (cr, 0, 0, 0) 
        cairo_set_line_width (cr, 30.0);
        cairo_set_line_cap  (cr, #CAIRO_LINE_CAP_BUTT); /* default */
        cairo_move_to (cr, 64.0, 50.0); 
        cairo_line_to (cr, 64.0, 200.0);
        cairo_stroke (cr);
        cairo_set_line_cap  (cr, #CAIRO_LINE_CAP_ROUND);
        cairo_move_to (cr, 128.0, 50.0); 
        cairo_line_to (cr, 128.0, 200.0);
        cairo_stroke (cr);
        cairo_set_line_cap  (cr, #CAIRO_LINE_CAP_SQUARE);
        cairo_move_to (cr, 192.0, 50.0); 
        cairo_line_to (cr, 192.0, 200.0);
        cairo_stroke (cr);
        
        
        cairo_set_source_rgb (cr, 1, 0.2, 0.2);
        cairo_set_line_width (cr, 2.56);
        cairo_move_to (cr, 64.0, 50.0); 
        cairo_line_to (cr, 64.0, 200.0);
        cairo_move_to (cr, 128.0, 50.0);  
        cairo_line_to (cr, 128.0, 200.0);
        cairo_move_to (cr, 192.0, 50.0); 
        cairo_line_to (cr, 192.0, 200.0);
        cairo_stroke (cr);
        cairo_restore(cr)
        refresh = 15
 EndProcedure 

 Procedure set_line_join(cr)
   
   clear_cr(cr)
    cairo_save(cr)
        cairo_set_source_rgb (cr, 0, 0, 0) 
        cairo_set_line_width (cr, 40.96);
        cairo_move_to (cr, 76.8, 84.48);
        cairo_rel_line_to (cr, 51.2, -51.2);
        cairo_rel_line_to (cr, 51.2, 51.2);
        cairo_set_line_join (cr, #CAIRO_LINE_JOIN_MITER); /* default */
        cairo_stroke (cr);
        
        cairo_move_to (cr, 76.8, 161.28);
        cairo_rel_line_to (cr, 51.2, -51.2);
        cairo_rel_line_to (cr, 51.2, 51.2);
        cairo_set_line_join (cr, #CAIRO_LINE_JOIN_BEVEL);
        cairo_stroke (cr);
        
        cairo_move_to (cr, 76.8, 238.08);
        cairo_rel_line_to (cr, 51.2, -51.2);
        cairo_rel_line_to (cr, 51.2, 51.2);
        cairo_set_line_join (cr, #CAIRO_LINE_JOIN_ROUND);
        cairo_stroke (cr)
     cairo_restore(cr)   
        refresh = 16
 EndProcedure 

 Procedure text_toy(cr)
   Protected xc.d, yc.d
   clear_cr(cr)
       cairo_save(cr)
       cairo_set_source_rgb (cr, 0, 0, 0) 
       xc = WindowWidth(1)/2;128.0
       yc = WindowHeight(1)/2;128.0
       cairo_select_font_face (cr, "Sans", #CAIRO_FONT_SLANT_NORMAL,#CAIRO_FONT_WEIGHT_BOLD);
       cairo_set_font_size (cr, 90.0);

      cairo_move_to (cr, 10.0, 135.0);
      cairo_show_text (cr, "Hello");
      
      cairo_move_to (cr, 70.0, 165.0);
      cairo_text_path (cr, "void");
      cairo_set_source_rgb (cr, 0.5, 0.5, 1);
      cairo_fill_preserve (cr);
      cairo_set_source_rgb (cr, 0, 0, 0);
      cairo_set_line_width (cr, 2.56);
      cairo_stroke (cr);

      cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.6);
      cairo_arc (cr, 10.0, 135.0, 5.12, 0, 2*#M_PI);
      cairo_close_path (cr);
;       cairo_fill (cr);
      cairo_arc (cr, 70.0, 165.0, 5.12, 0, 2*#M_PI);
      cairo_fill (cr);
      cairo_restore(cr)
      refresh = 17
 EndProcedure 

 Procedure text_center(cr)
   Protected xc.d, yc.d, utf8.s, x.d, y.d, extents.cairo_text_extents_t
   clear_cr(cr)
    
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 
    xc = WindowWidth(1)/2;128.0
    yc = WindowHeight(1)/2;128.0
    utf8 = "cairo";
        
        cairo_select_font_face (cr, "Sans",#CAIRO_FONT_SLANT_NORMAL, #CAIRO_FONT_WEIGHT_NORMAL);
        
        cairo_set_font_size (cr, 52.0);
        cairo_text_extents (cr, utf8, extents);
        x = xc-(extents\width/2 + extents\x_bearing);
        y = yc-(extents\height/2 + extents\y_bearing);
        
        cairo_move_to (cr, x, y);
        cairo_show_text (cr, utf8);
        
        cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.3);
        cairo_set_line_width (cr, 6.0);
        cairo_arc (cr, x, y, 10.0, 0, 2*#M_PI);
        cairo_fill (cr);
        cairo_move_to (cr, xc, 0);
        cairo_rel_line_to (cr, 0, yc*2);
        cairo_move_to (cr, 0, yc);
        cairo_rel_line_to (cr, xc*2, 0);
        cairo_stroke (cr)
        cairo_restore(cr)
        refresh = 18
 EndProcedure 

 Procedure text_extent(cr)
   Protected xc.d, yc.d, utf8.s, x.d, y.d, extents.cairo_text_extents_t
   clear_cr(cr)
    
    cairo_save(cr)
    cairo_set_source_rgb (cr, 0, 0, 0) 
    xc = WindowWidth(1)/2;128.0
    yc = WindowHeight(1)/2;128.0
     
    utf8 = "cairo";
          cairo_select_font_face (cr, "Sans",#CAIRO_FONT_SLANT_NORMAL,#CAIRO_FONT_WEIGHT_NORMAL);
          cairo_set_font_size (cr, 100.0);
          cairo_text_extents (cr, utf8, extents);
          x=25.0;
          y=150.0;
          cairo_move_to (cr, x,y);
          cairo_show_text (cr, utf8);
          cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.6);
          cairo_set_line_width (cr, 6.0);
          cairo_arc (cr, x, y, 10.0, 0, 2*#M_PI);
          cairo_fill (cr);
          cairo_move_to (cr, x,y);
          cairo_rel_line_to (cr, 0, -extents\height);
          cairo_rel_line_to (cr, extents\width, 0);
          cairo_rel_line_to (cr, extents\x_bearing, -extents\y_bearing);
          cairo_stroke (cr)
     cairo_restore(cr)   
     refresh = 19  
 EndProcedure 

 Procedure cairo_version_is()
   Protected tex
   tex = cairo_version_string()
   MessageRequester("cairo version", PeekS(tex))
 EndProcedure 

 Procedure save_with_cairo(su, filename.s, type.i = #cairo_example_pdf)
 Protected cr_temp, su_temp
 
 If su <> #Null

 Select type
 
 Case  #cairo_example_pdf
 su_temp = cairo_pdf_surface_create(filename+".pdf",600,620)
 cr_temp = cairo_create(su_temp)
 cairo_set_source_surface (cr_temp, su, 0, 0);
 cairo_paint (cr_temp) 
 
 Case  #cairo_example_svg
 su_temp = cairo_svg_surface_create(filename+".svg",600,620)
 cr_temp = cairo_create(su_temp)
 cairo_set_source_surface (cr_temp, su, 0, 0);
 cairo_paint (cr_temp) 
 
 
 Case  #cairo_example_png
 su_temp = cairo_image_surface_create(#CAIRO_FORMAT_ARGB32,600,620)
 cr_temp = cairo_create(su_temp)
 cairo_set_source_surface (cr_temp, su, 0, 0);
 cairo_paint (cr_temp) 
 cairo_surface_write_to_png(su_temp,filename+".png") 
 
 Case  #cairo_example_ps
 su_temp = cairo_ps_surface_create(filename+".ps",600,620)
 cr_temp = cairo_create(su_temp)
 cairo_set_source_surface (cr_temp, su, 0, 0);
 cairo_paint (cr_temp) 
 
 Default : MessageRequester("cairo examples", "please select a valid format")
 
 EndSelect 
 
 If cr_temp <> #Null
  cairo_surface_destroy(su_temp)
  cairo_destroy(cr_temp)
 EndIf 
 
 EndIf 
 
 
 EndProcedure 
 
 Global  x.d, y.d,w, h, image, cr,x1.d, y1.d, pat ,utf8.s, matrix.cairo_matrix_t, extents.cairo_text_extents_t


 If  OpenWindow(0,0,0,800,640,"cairo examples",#PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(2,640,10,150,25,"arc")
  ButtonGadget(3,640,40,150,25,"arc negative")
  ButtonGadget(4,640,70,150,25,"clip")
  ButtonGadget(5,640,100,150,25,"clip image")
  ButtonGadget(6,640,130,150,25,"curve rectangle")
  ButtonGadget(7,640,160,150,25,"curve to")
  ButtonGadget(8,640,190,150,25,"dashes")
  ButtonGadget(9,640,220,150,25,"fill and stroke")
  ButtonGadget(10,640,250,150,25,"fill style")
  ButtonGadget(11,640,280,150,25,"gradient")
  ButtonGadget(12,640,310,150,25,"image")
  ButtonGadget(13,640,340,150,25,"image pattern")
  ButtonGadget(14,640,370,150,25,"multi segment cap")
  ButtonGadget(15,640,400,150,25,"set line cap")
  ButtonGadget(16,640,430,150,25,"set line join")
  ButtonGadget(17,640,460,150,25,"text")
  ButtonGadget(18,640,490,150,25,"text align center")
  ButtonGadget(19,640,520,150,25,"text extents")
  ButtonGadget(20,640,550,150,25,"version")
  ButtonGadget(21,640,580,150,25,"Export")

  OpenWindow(1,10,10,600,620,"",#PB_Window_BorderLess)
  SetWindowColor(1,RGB(255,255,255))
  SetParent_(WindowID(1),WindowID(0))
  
  ; here you can create a surface for our cairo context
  ; in this Case it's the dc of our window 1, you can render
  ; in a gadget, window,  windowedscreen or a cairo surface.
  ; pdf , ps, png, svg files are supported too ;)
  
  su = cairo_win32_surface_create(GetDC_(WindowID(1))) 
  cr = cairo_create(su)
  

 Repeat
 events = WaitWindowEvent()
  wevents = EventWindow()

  Select wevents
 
 Case 0 ;------------------------- main window
 
 Select events
  Case #PB_Event_Gadget
     Select EventGadget()
      Case 2 : arc(cr)
      Case 3 : arc_negative(cr)
      Case 4 : clip(cr) 
      Case 5 : clip_image(cr,"img1.png") ; your image, png format
      Case 6 : curve_rectangle(cr)
      Case 7 : curve_to(cr)
      Case 8 : dashes(cr) 
      Case 9 : fill_and_stroke(cr) 
      Case 10: fill_style(cr)
      Case 11: gradient(cr)
      Case 12: image(cr, "img2.png") ; your image, png format
      Case 13: image_pattern(cr, "img3.png") ; your image, png format
      Case 14: multi_segment_cap(cr)
      Case 15: set_line_cap(cr)
      Case 16: set_line_join(cr)
      Case 17: text_toy(cr)
      Case 18: text_center(cr)
      Case 19: text_extent(cr)
      Case 20: cairo_version_is()
      Case 21
      save_with_cairo(su,"cairo_example")
      save_with_cairo(su,"cairo_example",#cairo_example_png)
      save_with_cairo(su,"cairo_example",#cairo_example_svg)
      save_with_cairo(su,"cairo_example",#cairo_example_ps)
    EndSelect
  Case #PB_Event_CloseWindow  
  quit = 1
  ; destroy our surface and cairo context
  cairo_surface_destroy(su) 
  cairo_destroy(cr)
 EndSelect 

 Case 1
  Select events
    Case #WM_ERASEBKGND
      InvalidateRect_(WindowID(1),@rr,#False)
      
    Case #WM_PAINT
      BeginPaint_(WindowID(1),@ps)
        Select refresh
          Case 2 : arc(cr)
          Case 3 : arc_negative(cr)
          Case 4 : clip(cr) 
          Case 5 : clip_image(cr,"pou.png") 
          Case 6 : curve_rectangle(cr)
          Case 7 : curve_to(cr)
          Case 8 : dashes(cr) 
          Case 9 : fill_and_stroke(cr) 
          Case 10: fill_style(cr)
          Case 11: gradient(cr)
          Case 12: image(cr, "pou.png")
          Case 13: image_pattern(cr, "pou.png")
          Case 14: multi_segment_cap(cr)
          Case 15: set_line_cap(cr)
          Case 16: set_line_join(cr)
          Case 17: text_toy(cr)
          Case 18: text_center(cr)
          Case 19: text_extent(cr)        
        EndSelect
      EndPaint_(WindowID(1),@ps)
  EndSelect 
  EndSelect  
 Until quit = 1


 EndIf  
 
 End 



;} 
;
; ================================================================================


; IDE Options = PureBasic 5.10 (Windows - x86)
; CursorPosition = 772
; FirstLine = 134
; Folding = BAAw
; EnableXP